#define  dSource        "m:/temp/"
#define  dDistan        "m:/log.txt"
#define  dwBuffSize      0xf000

#ifndef _WIN32_WINNT		
#define _WIN32_WINNT 0x0400
#endif		

#include "stdio.h"
#include "windows.h"

struct SOMETHING
{	
	HANDLE hDir;
	char *sOut;
	BYTE *lpBuffer;
};

char *sSource, *sDistan;

void wtoc(WORD * w, char * c)//widechar to char
{
	int i = 0;
	while (*(w+i)!=0)
	{
		*(c+i)=*(w+i);
		i++;
	}
	*(c+i)=0;
}

DWORD NotifyDir(LPVOID p)
{

	SOMETHING *smgNotify = (SOMETHING *)p;

	OVERLAPPED o = { };
    o.hEvent = CreateEvent(0, FALSE, FALSE, 0);

    bool bStop = false;

	while(!bStop)
	{

		DWORD dwReturnedBytes = 0;
        ReadDirectoryChangesW(smgNotify->hDir,smgNotify->lpBuffer, dwBuffSize, FALSE, FILE_NOTIFY_CHANGE_FILE_NAME | FILE_NOTIFY_CHANGE_DIR_NAME | FILE_NOTIFY_CHANGE_SIZE | FILE_NOTIFY_CHANGE_CREATION, &dwReturnedBytes,&o, NULL);
		DWORD dwWaitStatus = WaitForSingleObject(o.hEvent, INFINITE);
 
        switch(dwWaitStatus) 
        { 
			case WAIT_OBJECT_0: 
			{
				DWORD dwSeek = 0;
                while(dwSeek < dwBuffSize)
                {
					PFILE_NOTIFY_INFORMATION pNotify = PFILE_NOTIFY_INFORMATION(smgNotify->lpBuffer + dwSeek);
                    dwSeek += pNotify->NextEntryOffset;

					char * sName = new char[pNotify->FileNameLength/2+1];
					pNotify->FileName[pNotify->FileNameLength/2] = 0;
					wtoc((WORD *)pNotify->FileName,sName);

					FILE *f = fopen(smgNotify->sOut,"a");

					switch (pNotify->Action)
					{
						case  FILE_ACTION_ADDED:
							fprintf(f,"'%s' was created\n",sName);
							break;

						case  FILE_ACTION_REMOVED:
							fprintf(f,"'%s' was deleted\n",sName);
							break;

						case FILE_ACTION_MODIFIED:	
							fprintf(f,"'%s' was modifed\n",sName);
							break;

						case FILE_ACTION_RENAMED_OLD_NAME:
							fprintf(f,"'%s' renamed to ",sName);
							break;

						case FILE_ACTION_RENAMED_NEW_NAME:
							fprintf(f,"'%s'\n",sName);
							break;
					}

					delete [] sName;
					fclose(f);

                    if(pNotify->NextEntryOffset == 0)
						break;
                } 
            }
            break; 
            default: 
				bStop = true;
            break;	
		} 
	}

    CloseHandle(o.hEvent);
	return 0; 
}


int main(int argc, char *argv[])
{
	
	if(argc<=1)
	{
		sSource = (char*)malloc(strlen(dSource)+1);
		strcpy(sSource,dSource);
		sDistan = (char*)malloc(strlen(dDistan)+1);
		strcpy(sDistan,dDistan);
	}
	else
	{
		sSource = (char*)malloc(strlen(argv[1])+1);
		strcpy(sSource,argv[1]);
		sDistan = (char*)malloc(strlen(argv[2])+1);
		strcpy(sDistan,argv[2]);
	}

	SOMETHING smgNotify;

	smgNotify.hDir = CreateFile(sSource, FILE_LIST_DIRECTORY , FILE_SHARE_WRITE|FILE_SHARE_READ|
		FILE_SHARE_DELETE, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS | FILE_FLAG_OVERLAPPED, 0);
	smgNotify.sOut = sDistan;
	smgNotify.lpBuffer = new BYTE[dwBuffSize];

	DWORD dwThreadID;
	HANDLE hThread = CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)&NotifyDir,(LPVOID)&smgNotify,0,&dwThreadID);

	if (hThread == 0)
	{
		printf("Error!");
	}
	else
	{
		printf("From: %s\n\r",sSource);
		printf("To  : %s\n\r",sDistan);
	}

	printf("Press Enter to stop");
	getchar();

	TerminateThread(hThread,0);
	free(sSource);
	free(sDistan);
	CloseHandle(smgNotify.hDir);
	delete [] smgNotify.lpBuffer;

	return 0;
}