#define  dwBuffSize      0xf000

#ifndef _WIN32_WINNT		
#define _WIN32_WINNT 0x0400
#endif		

#include "windows.h"

class Buffer
{
private:
	BYTE *lpBuffer;
public:
	Buffer()
	{
		this->lpBuffer = NULL;
	}
	SetSize(DWORD size)
	{
		this->lpBuffer = new BYTE[size];
	}
	~Buffer()
	{
		delete[] this->lpBuffer;
	}
	operator BYTE*() const
	{
		return this->lpBuffer;
	}
};

class HandleToFolder
{
private:
	HANDLE hDir;
public:
	HandleToFolder()
	{
		this->hDir=0;
	}
	~HandleToFolder()
	{
		CloseHandle(this->hDir);
	}
	HandleToFolder& operator=(HANDLE orig)
	{
		CloseHandle(this->hDir);
		this->hDir = orig;
		return *this;
	}
	operator HANDLE() const
	{
		return this->hDir;
	}
};

struct SOMETHING
{	
	HandleToFolder hDir;
	char *sOut;
	Buffer lpBuffer;
};

void wtoc(WORD * w, char * c)
{
	int i = 0;
	while (*(w+i)!=0)
	{
		*(c+i)=*(w+i);
		i++;
	}
	*(c+i)=0;
}

DWORD NotifyDir(LPVOID p)
{

	SOMETHING *smgNotify = (SOMETHING *)p;

	OVERLAPPED o = { };
	o.hEvent = CreateEvent(0, FALSE, FALSE, 0);

	bool bStop = false;

	while(!bStop)
	{

		DWORD dwReturnedBytes = 0;
		ReadDirectoryChangesW(smgNotify->hDir,smgNotify->lpBuffer, dwBuffSize, FALSE, FILE_NOTIFY_CHANGE_FILE_NAME | FILE_NOTIFY_CHANGE_DIR_NAME | FILE_NOTIFY_CHANGE_SIZE | FILE_NOTIFY_CHANGE_CREATION, &dwReturnedBytes,&o, NULL);
		DWORD dwWaitStatus = WaitForSingleObject(o.hEvent, INFINITE);
 
		switch(dwWaitStatus) 
		{ 
			case WAIT_OBJECT_0: 
			{
				DWORD dwSeek = 0;
				while(dwSeek < dwBuffSize)
				{
					PFILE_NOTIFY_INFORMATION pNotify = PFILE_NOTIFY_INFORMATION(smgNotify->lpBuffer + dwSeek);
					dwSeek += pNotify->NextEntryOffset;

					char * sName = new char[pNotify->FileNameLength/2+1];
					pNotify->FileName[pNotify->FileNameLength/2] = 0;
					wtoc((WORD *)pNotify->FileName,sName);

					FILE *f = fopen(smgNotify->sOut,"a");

					switch (pNotify->Action)
					{
						case  FILE_ACTION_ADDED:
							fprintf(f,"'%s' was created\n",sName);
							break;

						case  FILE_ACTION_REMOVED:
							fprintf(f,"'%s' was deleted\n",sName);
							break;

						case FILE_ACTION_MODIFIED:	
							fprintf(f,"'%s' was modifed\n",sName);
							break;

						case FILE_ACTION_RENAMED_OLD_NAME:
							fprintf(f,"'%s' was renamed to ",sName);
							break;

						case FILE_ACTION_RENAMED_NEW_NAME:
							fprintf(f,"'%s'\n",sName);
							break;
					}

					delete [] sName;
					fclose(f);

					if(pNotify->NextEntryOffset == 0)
						break;
				} 
			}
			break; 
			default: 
				bStop = true;
				break;	
		}	 
	}

	CloseHandle(o.hEvent);
	return 0; 
}

class Notifer
{
private:

	SOMETHING smgNotify;
	HANDLE hThread;

public:
	Notifer(char * in, char * out)
	{
		this->smgNotify.hDir = CreateFile(in, FILE_LIST_DIRECTORY , FILE_SHARE_WRITE|FILE_SHARE_READ|FILE_SHARE_DELETE, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, 0);
		if (this->smgNotify.hDir == 0)
			throw 1;

		this->smgNotify.sOut = out;

		this->smgNotify.lpBuffer.SetSize(dwBuffSize);
		if (this->smgNotify.lpBuffer == NULL)
			throw 2;
		
		DWORD dwThreadID;
		this->hThread = CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)&NotifyDir,(LPVOID)&(this->smgNotify),0,&dwThreadID);

		if	(this->hThread == 0)
			throw 3;
	}
	~Notifer()
	{
		TerminateThread(this->hThread,0);
		CloseHandle(this->hThread);
	}

};